HDU 1080-Super Jumping! Jumping! Jumping!(LIS最长上升子序列-最大递增子段和)

来源:互联网 发布:软件配置管理规定 编辑:程序博客网 时间:2024/05/21 09:47

Super Jumping! Jumping! Jumping!

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)
Total Submission(s): 32237    Accepted Submission(s): 14521


Problem Description
Nowadays, a kind of chess game called “Super Jumping! Jumping! Jumping!” is very popular in HDU. Maybe you are a good boy, and know little about this game, so I introduce it to you now.



The game can be played by two or more than two players. It consists of a chessboard(棋盘)and some chessmen(棋子), and all chessmen are marked by a positive integer or “start” or “end”. The player starts from start-point and must jumps into end-point finally. In the course of jumping, the player will visit the chessmen in the path, but everyone must jumps from one chessman to another absolutely bigger (you can assume start-point is a minimum and end-point is a maximum.). And all players cannot go backwards. One jumping can go from a chessman to next, also can go across many chessmen, and even you can straightly get to end-point from start-point. Of course you get zero point in this situation. A player is a winner if and only if he can get a bigger score according to his jumping solution. Note that your score comes from the sum of value on the chessmen in you jumping path.
Your task is to output the maximum value according to the given chessmen list.
 

Input
Input contains multiple test cases. Each test case is described in a line as follow:
N value_1 value_2 …value_N
It is guarantied that N is not more than 1000 and all value_i are in the range of 32-int.
A test case starting with 0 terminates the input and this test case is not to be processed.
 

Output
For each case, print the maximum according to rules, and one line one case.
 

Sample Input
3 1 3 24 1 2 3 44 3 3 2 10
 

Sample Output
4103
 

Author
lcy
 

Recommend
We have carefully selected several similar problems for you:  1003 1176 1069 1058 1203

题目意思:

有N个数字构成的序列,求最大递增子段和,即递增子序列和的最大值。

解题思路:

定义dp[i];//以a[i]结尾的最大递增子段和。
双重for循环,每次求出以a[i]结尾的最大递增子段和

#include<cstdio>#include<cstring>#include<iostream>#include<algorithm>using namespace std;#define MAXN 10010int dp[MAXN];//以a[i]结尾的最大递增子段和int a[MAXN];//初始序列int main(){    int n;    while(cin>>n,n)    {        int i,j;        memset(a,0,sizeof(a));        for(i=0; i<n; ++i)//输入数据            cin>>a[i];        int ans;        for(i=0; i<n; ++i)        {            ans=0;            for(j=0; j<i; ++j)                if(a[j]<a[i])//如果可构成递增序列                    ans=max(dp[j],ans);//求各递增情况的最大值            dp[i]=ans+a[i];//之前算的是a[i]之前的递增和,所以最后要加上a[i]        }        ans=*max_element(dp,dp+n);//求出所有最大递增子段和的最大值        cout<<ans<<endl;    }    return 0;}/*3 1 3 24 1 2 3 44 3 3 2 10*/

 
0 0
原创粉丝点击